//########## BTR-60

//### Sound

datablock AudioProfile(gc_BTR60FireSound)
{
  filename = "./btr60fire.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_BTR60ShellImpactSound)
{
  filename = "./btr60impact.wav";
  description = AudioClose3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_tireParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.4 0.4 0.4 0.3";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 2;
  sizes[1] = 6;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_tireEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_tireParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_vehicleDamageParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = -2;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0";
  colors[1] = "0 0 0 0.5";
  colors[2] = "0 0 0 0";
  sizes[0] = 3;
  sizes[1] = 4;
  sizes[2] = 6;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_vehicleDamageEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_vehicleDamageParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_BTR60EngineParticle)
{
  dragCoefficient = 2;
  gravityCoefficient = -1;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0.3";
  colors[1] = "0 0 0 0";
  sizes[0] = 0.5;
  sizes[1] = 5;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_BTR60EngineEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 4;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 20;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_BTR60EngineParticle";
  useEmitterColors = true;
};

datablock ShapeBaseImageData(gc_BTR60EngineImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 8;

  stateName[0] = "Smoke";
  stateTransitionOnTimeout[0] = "Smoke";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 1000;
  stateEmitter[0] = gc_BTR60EngineEmitter;
  stateEmitterTime[0] = 1000;
};

datablock ParticleData(gc_BTR60FlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 0.5 0 1";
  colors[1] = "1 0.8 0.6 1";
  colors[2] = "1 0.3 0.1 0";
  sizes[0] = 0.1;
  sizes[1] = 2;
  sizes[2] = 0;
  times[9] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_BTR60FlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 250;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_BTR60FlashParticle";
};

datablock ParticleData(gc_BTR60SmokeParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0.2;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 600;
  lifetimeVarianceMS = 200;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 1 1 0.1";
  colors[1] = "1 1 1 0";
  sizes[0] = 1;
  sizes[1] = 5;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_BTR60SmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 6;
  periodVarianceMS = 0;
  ejectionVelocity = 30;
  velocityVariance = 20;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 20;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_BTR60SmokeParticle";
};

datablock ShapeBaseImageData(gc_BTR60FireImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "FireB";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 0.1;
  stateEmitter[0] = gc_BTR60FlashEmitter;
  stateEmitterTime[0] = 0.05;

  stateName[1] = "FireB";
  stateTransitionOnTimeout[1] = "Done";
  stateWaitForTimeout[1] = true;
  stateTimeoutValue[1] = 0.1;
  stateEmitter[1] = gc_BTR60SmokeEmitter; 
  stateEmitterTime[1] = 0.1;

  stateName[2] = "Done";
  stateScript[2] = "onDone";
};

function gc_BTR60FireImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ParticleData(gc_BTR60ShellExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 100;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/star1";
  spinSpeed = 0;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "1 0.6 0.2 1";
  colors[1] = "1 0 0 0";
  sizes[0] = 2;
  sizes[1] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_BTR60ShellExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_BTR60ShellExplosionParticle";
};

datablock ParticleData(gc_BTR60ShellSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -1;
  spinRandomMax = 1;
  colors[0] = "0 0 0 0.5";
  colors[1] = "0 0 0 0";
  sizes[0] = 2;
  sizes[1] = 4;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_BTR60ShellSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 5;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 5;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_BTR60ShellSmokeParticle";
};

datablock ExplosionData(gc_BTR60ShellExplosion)
{
  lifeTimeMS = 100;
  emitter[0] = gc_BTR60ShellExplosionEmitter;
  emitter[1] = gc_BTR60ShellSmokeEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  damageRadius = 1;
  radiusDamage = 20;
  impulseRadius = 2;
  impulseForce = 35;
  soundProfile = gc_BTR60ShellImpactSound;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "8 8 8";
  camShakeDuration = 2;
  camShakeRadius = 4;
};

datablock DebrisData(gc_BTR60ShellDebris)
{
  shapeFile = "./shell.dts";
  lifetime = 2;
  minSpinSpeed = -200;
  maxSpinSpeed = 200;
  elasticity = 0.5;
  friction = 0.2;
  numBounces = 3;
  staticOnMaxBounce = true;
  snapOnMaxBounce = false;
  fade = true;
  gravModifier = 2;
};

datablock ShapeBaseImageData(gc_BTR60ShellImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  mountPoint = 2;
  casing = gc_BTR60ShellDebris;
  shellExitDir = "1 0 0.2";
  shellExitVariance = 10;
  shellVelocity = 10;

  stateName[0] = "Fire";
  stateEjectShell[0] = true;
  stateTransitionOnTimeout[0] = "Done";
  stateWaitForTimeout[0] = false;
  stateTimeoutValue[0] = 0.1;

  stateName[1] = "Done";
  stateScript[1] = "onDone";
};
function gc_BTR60ShellImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

//### Projectile

AddDamageType("gc_BTR60",'<color:ff0000>BTR-60</color>%1','%2<color:ff0000>BTR-60</color>%1',1,1);

datablock ProjectileData(gc_BTR60ShellProjectile)
{
  uiName = "";
  projectileShapeName = "./projectile.dts";
  directDamage = 35;
  directDamageType = $DamageType::gc_BTR60;
  radiusDamageType = $DamageType::gc_BTR60;
  brickExplosionRadius = 2;
  brickExplosionImpact = true;
  brickExplosionForce = 25;
  brickExplosionMaxVolume = 12;
  brickExplosionMaxVolumeFloating = 12;
  impactImpulse = 200;
  explosion = gc_BTR60ShellExplosion;
  muzzleVelocity = 200;
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 5000;
  fadeDelay = 5000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0.25;
  explodeOnDeath = 1;
};

//### Turret

datablock TSShapeConstructor(btr60turretDts)
{
  baseShape = "./btr60turret.dts";
  sequence0 = "./root.dsq root";
  sequence1 = "./look.dsq look";
};

datablock PlayerData(gc_BTR60TurretPlayer)
{
  renderFirstPerson = true;
  emap = false;
  className = Armor;
  shapeFile = "./btr60turret.dts";
  cameraMaxDist = 8;
  cameraTilt = 0.261;
  cameraVerticalOffset = 2.3;
  cameraDefaultFov = 90;
  cameraMinFov = 5;
  cameraMaxFov = 120;
  aiAvoidThis = true;
  minLookAngle = -0.35;
  maxLookAngle = 0.16;
  maxFreelookAngle = 3;
  mass = 200000;
  drag = 1;
  density = 5;
  maxDamage = 400;
  maxEnergy = 10;
  repairRate = 0.33;
  rechargeRate = 0.4;
  runForce = 1000;
  runEnergyDrain = 0;
  minRunEnergy = 0;
  maxForwardSpeed = 0;
  maxBackwardSpeed = 0;
  maxSideSpeed = 0;
  maxForwardCrouchSpeed = 0;
  maxBackwardCrouchSpeed = 0;
  maxSideCrouchSpeed = 0;
  maxUnderwaterForwardSpeed = 0;
  maxUnderwaterBackwardSpeed = 0;
  maxUnderwaterSideSpeed = 0;
  jumpForce = 0;
  jumpEnergyDrain = 0;
  minJumpEnergy = 0;
  jumpDelay = 0;
  minJetEnergy = 0;
  jetEnergyDrain = 0;
  canJet = 0;
  minImpactSpeed = 250;
  speedDamageScale = 3.8;
  boundingBox = "10 10 2";
  crouchBoundingBox = "10 10 2";
  pickupRadius = 0.75;
  jetEmitter = "";
  jetGroundEmitter = "";
  jetGroundDistance = 4;
  splash = PlayerSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 0.1;
  splashEmitter[0] = PlayerFoamDropletsEmitter;
  splashEmitter[1] = PlayerFoamEmitter;
  splashEmitter[2] = PlayerBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  runSurfaceAngle = 85;
  jumpSurfaceAngle = 86;
  minJumpSpeed = 20;
  maxJumpSpeed = 30;
  horizMaxSpeed = 68;
  horizResistSpeed = 33;
  horizResistFactor = 0.35;
  upMaxSpeed = 80;
  upResistSpeed = 25;
  upResistFactor = 0.3;
  footstepSplashHeight = 0.35;
  JumpSound = "";
  groundImpactMinSpeed = 10;
  groundImpactShakeFreq = "4 4 4";
  groundImpactShakeAmp = "1 1 1";
  groundImpactShakeDuration = 0.8;
  groundImpactShakeFalloff = 10;
  maxItems = 10;
  maxWeapons = 5;
  maxTools = 5;
  uiName = "";
  rideable = true;
  lookUpLimit = 0.6;
  lookDownLimit = 0.4;
  canRide = false;
  showEnergyBar = false;
  paintable = true;
  brickImage = horseBrickImage;
  numMountPoints = 1;
  mountThread[0] = "sit";
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
  useCustomPainEffects = true;
  PainHighImage = "";
  PainMidImage = "";
  PainLowImage = "";
  painSound = "";
  deathSound = "";
  useEyePoint = 1;
};

//### Vehicle

datablock WheeledVehicleTire(gc_BTR60Tire)
{
  shapeFile = "./tire.dts";
  mass = 5;
  radius = 0.7;
  staticFriction = 5;
  kineticFriction = 5;
  restitution = 0.5;
  lateralForce = 18000;
  lateralDamping = 4000;
  lateralRelaxation = 0.01;
  longitudinalForce = 14000;
  longitudinalDamping = 2000;
  longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(gc_BTR60Spring)
{
  length = 0.4;
  force = 5000;
  damping = 1500;
  antiSwayForce = 30;
};

datablock DebrisData(gc_BTR60TireDebris)
{
  shapeFile = "./tire.dts";
  lifetime = 2;
  minSpinSpeed = -400;
  maxSpinSpeed = 200;
  elasticity = 0.5;
  friction = 0.2;
  numBounces = 3;
  staticOnMaxBounce = true;
  snapOnMaxBounce = false;
  fade = true;
  gravModifier = 2;
};

datablock ExplosionData(gc_BTR60Explosion : vehicleExplosion)
{
  debris = gc_BTR60TireDebris;
  debrisNum = 8;
  debrisNumVariance = 0;
  debrisPhiMin = 0;
  debrisPhiMax = 360;
  debrisThetaMin = 40;
  debrisThetaMax = 85;
  debrisVelocity = 14;
  debrisVelocityVariance = 3;
};

datablock ProjectileData(gc_BTR60ExplosionProjectile : vehicleExplosionProjectile)
{
  uiName = "";
  explosion = gc_BTR60Explosion;
};

datablock WheeledVehicleData(gc_BTR60Vehicle)
{
  uiName = "BTR";
  category = "Vehicles";
  displayName = "";
  shapeFile = "./btr60.dts";
  emap = true;
  minMountDist = 3;
  numMountPoints = 8;
  mountThread[0] = "sit";
  mountThread[1] = "sit";
  mountThread[2] = "sit";
  mountThread[3] = "sit";
  mountThread[4] = "sit";
  mountThread[5] = "sit";
  mountThread[6] = "sit";
  mountThread[7] = "sit";
  maxDamage = 300;
  destroyedLevel = 300;
  speedDamageScale = 1.04;
  collDamageThresholdVel = 20;
  collDamageMultiplier = 0.02;
  massCenter = "0 0 -0.5";
  maxSteeringAngle = 0.9;
  integration = 4;
  tireEmitter = gc_tireEmitter;
  cameraRoll = false;
  cameraMaxDist = 13;
  cameraOffset = 6;
  cameraLag = 0.0;
  cameraDecay = 0.75;
  cameraTilt = 0.4;
  collisionTol = 0.1;
  contactTol = 0.1;
  defaultTire = gc_BTR60Tire;
  defaultSpring = gc_BTR60Spring;
  numWheels = 8;
  mass = 400;
  density = 5;
  drag = 1.6;
  bodyFriction = 0.6;
  bodyRestitution = 0.6;
  minImpactSpeed = 10;
  softImpactSpeed = 10;
  hardImpactSpeed = 15;
  groundImpactMinSpeed = 10;
  engineTorque = 1000;
  engineBrake = 500;
  brakeTorque = 1000;
  maxWheelSpeed = 30;
  rollForce = 900;
  yawForce = 600;
  pitchForce = 1000;
  rotationalDrag = 0.2;
  maxEnergy = 100;
  jetForce = 3000;
  minJetEnergy = 30;
  jetEnergyDrain = 2;
  splash = vehicleSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 1.4;
  splashEmitter[0] = vehicleFoamDropletsEmitter;
  splashEmitter[1] = vehicleFoamEmitter;
  splashEmitter[2] = vehicleBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  softImpactSound = slowImpactSound;
  hardImpactSound = fastImpactSound;
  justcollided = 0;
  rideable = true;
  lookUpLimit = 0.6;
  lookDownLimit = 0.4;
  trailEmitter = gc_vehicleDamageEmitter;
  minTrailSpeed = 2;
  paintable = true;
  damageEmitter[0] = gc_vehicleDamageEmitter;
  damageEmitterOffset[0] = "0 -2 1";
  damageLevelTolerance[0] = 0.5;
  damageEmitter[1] = VehicleBurnEmitter;
  damageEmitterOffset[1] = "0 -2 1";
  damageLevelTolerance[1] = 0.9;
  numDmgEmitterAreas = 1;
  initialExplosionProjectile = gc_BTR60ExplosionProjectile;
  initialExplosionOffset = 0;
  burnTime = 4000;
  finalExplosionProjectile = vehicleFinalExplosionProjectile;
  finalExplosionOffset = 0;
  minRunOverSpeed = 4;
  runOverDamageScale = 25;
  runOverPushScale = 1.2;
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;

  dismountOffset[0] = "0 -5.5 0.2";
  dismountAngle[0] = 180;
};

//### Functions

function gc_BTR60Vehicle::onAdd(%this,%obj)
{
  parent::onAdd(%this,%obj);
  %obj.setWheelPowered(0,true);
  %obj.setWheelPowered(1,true);
  %obj.setWheelPowered(2,true);
  %obj.setWheelPowered(3,true);
  %obj.setWheelPowered(4,true);
  %obj.setWheelPowered(5,true);
  %obj.setWheelPowered(6,true);
  %obj.setWheelPowered(7,true);
  %t = new AIPlayer() { dataBlock = gc_BTR60TurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,1);
  %obj.turret = %t;
  schedule(500,0,gc_Overheating,%t);
  gc_BTR60EngineCheck(%obj);
}

function gc_BTR60EngineCheck(%obj)
{
  if(!isObject(%obj)) return;
  if(!isObject(%obj.getMountNodeObject(0))) %obj.unMountImage(3);
  else
    %obj.mountImage(gc_BTR60EngineImage,3);
  Schedule(2000,0,"gc_BTR60EngineCheck",%obj);
}

function gc_BTR60Vehicle::onRemove(%this,%obj) { if(isObject(%obj.turret)) { %obj.turret.delete(); } }

package gc_BTR60Package
{
  function Armor::doDismount(%this,%obj,%forced,%vehicle)
  {
    parent::doDismount(%this,%obj,%forced,%vehicle);
    if(isObject(%obj.gc_BTRDoor))
    {
      cancel(%obj.gc_BTRDoor.gc_BTRDoorLoop);
      %obj.gc_BTRDoor.playThread(0,dooropen);
      %obj.gc_BTRDoor.gc_BTRDoorLoop = %obj.gc_BTRDoor.schedule(1000,playThread,0,doorclose);
      %obj.gc_BTRDoor = "";
    }
  }
  function Armor::onUnMount(%this,%obj,%vehicle,%slot)
  {
    parent::onUnMount(%this,%obj,%vehicle,%slot);
    if(%vehicle.dataBlock $= gc_BTR60Vehicle) %obj.gc_BTRDoor = %vehicle;
  }
  function Player::Burn(%obj,%time)
  {
    if(%obj.dataBlock $= gc_BTR60TurretPlayer) return;
    parent::Burn(%obj,%time);
  }
  function ShapeBase::setNodeColor(%obj,%node,%color)
  {
    parent::setnodecolor(%obj,%node,%color);
    if(isObject(%obj.turret)) %obj.turret.setNodeColor("ALL",%color);
  }
  function gc_BTR60Vehicle::Damage(%this,%obj,%source,%pos,%amount,%type)
  {
    if(%amount < 40) %amount /= 2;
    if((%obj.getDamageLevel()+%amount) >= %this.maxDamage)
    {
      if(%obj.destroyed) return;
      for(%i=0;%i<%this.numWheels;%i++) { %obj.setWheelTire(%i,emptyTire); }
      %obj.setNodeColor("ALL","0 0 0 1");
      if(isObject(%obj.turret)) %obj.turret.delete();
      %p = new Projectile()
      {
        dataBlock = %this.initialExplosionProjectile;
        initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
        initialVelocity = "0 0 1";
        client = %obj.lastDamageClient;
        sourceClient = %obj.lastDamageClient;
      };
      MissionCleanup.add(%p);
      if(%obj.destroyed) return;
      %obj.setDamageLevel(%this.maxDamage);
      %obj.destroyed = 1;
      %obj.schedule(%this.burnTime,"finalExplosion");
      if(isObject(%obj.spawnBrick.client.minigame)) %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
      %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
    }
    else
      parent::Damage(%this,%obj,%source,%pos,%amount,%type);
  }
  function gc_BTR60TurretPlayer::Damage(%this,%obj,%source,%pos,%amount,%type) { parent::Damage(%this,%obj,%source,%pos,0,%type); }
  function Armor::onMount(%this,%obj,%col,%slot)
  {
    parent::onMount(%this,%obj,%col,%slot);
    if(isObject(%obj.client)) {
      if(%col.getDataBlock() == gc_BTR60TurretPlayer.getId()) ServerCmdUnUseTool(%obj.client); }
  }
  function Armor::onTrigger(%this,%obj,%triggerNum,%val)
  {
    %mount = %obj.getObjectMount();
    if(isObject(%mount))
    {
      if(!%val) cancel(%obj.gc_BTR60Loop);
      if(%mount.getDataBlock() == gc_BTR60TurretPlayer.getId() && %triggerNum == 0 && %val)
        if(getSimTime() - %obj.lastShotTime > 250) { %obj.gc_BTR60Fire(%val); %obj.lastShotTime = getSimTime(); }
    }
    parent::onTrigger(%this,%obj,%triggerNum,%val);
  }
  function Player::gc_BTR60Fire(%obj,%val)
  {
    if(!%val) { cancel(%obj.gc_BTR60Loop); return; }
    if(!isObject(%obj.getObjectMount())) { cancel(%obj.gc_BTR60Loop); return; }
    if(%obj.getObjectMount().getDataBlock() != gc_BTR60TurretPlayer.getId()) { cancel(%obj.gc_BTR60Loop); return; }
    if(%obj.getObjectMount().temp >= 80 & %obj.getObjectMount().overheat == 0) { serverPlay3D(gc_OverheatSound,%obj.getPosition()); %obj.getObjectMount().overheat = 1; %obj.getObjectMount().mountImage(gc_OverheatMount1Image,1); cancel(%obj.gc_BTR60Loop); return; }
    if(%obj.getObjectMount().overheat == 1) {
      if(%obj.getObjectMount().temp >= 10) { cancel(%obj.gc_BTR60Loop); return; }
      else
        { %obj.getObjectMount().overheat = 0; } }
    %client = %obj.client;
    if(isObject(%client)) ServerCmdUnUseTool(%client);
    %mount = %obj.getObjectMount();
    %scaleFactor = getWord(%mount.getScale(),2);
    %p = new Projectile()
    {
      dataBlock = gc_BTR60ShellProjectile;
      initialPosition = %mount.getSlotTransform(1);
      initialVelocity = MatrixMulVector(MatrixCreateFromEuler(((getRandom()-0.5)*0.006) SPC ((getRandom()-0.5)*0.006) SPC ((getRandom()-0.5)*0.006)),VectorScale(%mount.getMuzzleVector(1),200));
      sourceObject = %obj;
      client = %client;
      sourceSlot = 0;
      originPoint = %mount.getSlotTransform(1);
    };
    MissionCleanup.add(%p);
    %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
    %mount.mountImage(gc_BTR60FireImage,1);
    %mount.mountImage(gc_BTR60ShellImage,2);
    serverPlay3D(gc_BTR60FireSound,%obj.getPosition());
    %mount.temp += 8;
    %col = "<color:00ff00>";
    if(%mount.temp > 40) %col = "<color:ffff00>";
    if(%mount.temp > 60) %col = "<color:ff0000>";
    for(%i=0;%i<=(%mount.temp/5);%i++) { %a = %a @ "|"; }
    bottomPrint(%obj.client,%col @ "Barrel Temp: " @ %a,2);
    %obj.gc_BTR60Loop = %obj.schedule(250,gc_BTR60Fire,%val);
    return;
  }
};
activatepackage(gc_BTR60Package);
