//########## Overheating feature for turrets/etc.

//### Sound

datablock AudioProfile(gc_OverheatSound)
{
  filename = "./overheat.wav";
  description = AudioClose3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_OverheatParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = -1.5;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 600;
  lifetimeVarianceMS = 200;
  textureName = "base/data/particles/cloud";
  spinSpeed = 1;
  spinRandomMin = -5;
  spinRandomMax = 5;
  colors[0] = "1 1 1 0.8";
  colors[1] = "1 1 1 0";
  sizes[0] = 0.2;
  sizes[1] = 0.8;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_OverheatEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 0;
  ejectionVelocity = 1;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_OverheatParticle";
  useEmitterColors = true;
};

datablock ShapeBaseImageData(gc_OverheatMount1Image)
{
  shapeFile = "base/data/shapes/empty.dts";
  mountPoint = 1;

  stateName[0] = "Fire";
  stateTransitionOnTimeout[0] = "Done";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 2;
  stateEmitter[0] = gc_OverheatEmitter;
  stateEmitterTime[0] = 2;

  stateName[1] = "Done";
  stateScript[1] = "onDone";
};
function gc_OverheatMount1Image::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ShapeBaseImageData(gc_OverheatMount2Image)
{
  shapeFile = "base/data/shapes/empty.dts";
  mountPoint = 2;

  stateName[0] = "Fire";
  stateTransitionOnTimeout[0] = "Done";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 2;
  stateEmitter[0] = gc_OverheatEmitter;
  stateEmitterTime[0] = 2;

  stateName[1] = "Done";
  stateScript[1] = "onDone";
};
function gc_OverheatMount2Image::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

//### Functions

function gc_Overheating(%obj)
{
  if(!isObject(%obj)) return;
  schedule(500,0,gc_Overheating,%obj);
  if(%obj.temp > 0) %obj.temp -= 6;
  if(%obj.temp < 0) %obj.temp = 0;
  if(isObject(%obj.getMountNodeObject(0))) {
  %col = "<color:00ff00>";
  if(%obj.temp > 40) %col = "<color:ffff00>";
  if(%obj.temp > 60) %col = "<color:ff0000>";
  if(%obj.overheat) %col = "<color:ff0000>";
  for(%i=0;%i<=(%obj.temp/5);%i++) { %a = %a @ "|"; }
  bottomPrint(%obj.getMountNodeObject(0).client,%col @ "Barrel Temp: " @ %a,2); }
}
